local addonName, vars = ...				
local L = vars.L				
Profession_RP = vars				
local addon = Profession_RP				
local addonsls = "/PrRP"				
local settings				
--	7	(7)		
local defaults = {				
	enabled = true,			
	sound = true,			
	say = true,			
	summon = true,			
	link = false,
	debug = false,
	playfrequency = 5,			
	pet = 1,			
	list = 2,			
}				
				
local pet_n = {				
	[1] = "BattlePet-0-00000486CF51",			-- magic
	[2] = "BattlePet-0-00000486CE3C",			-- mech
	[3] = "BattlePet-0-00000486CE12",			-- dragon
}				
				
local deb_tex = {				
	[1] = "Give me your skin!",			
	[2] = "Pull .,. Pull",			
	[3] = "Wack .,. Wack",			
	[4] = "Whats that",			
	[5] = "say ",			
}				
--	32	(25)		
local soundfiles = {				
	[1] = {			
		WEF_F_Agree	= {p=1, t=1},	
		WEF_F_Disagree	= {p=1, t=1},	
		WEF_F_Follow	= {p=1, t=1},	
		WEF_F_Greet	= {p=1, t=1},	
		WEF_F_Heal	= {p=1, t=1},	
		WEF_F_Help	= {p=1, t=1},	
		WEF_F_Laugh	= {p=1, t=1},	
		WEF_F_Stop	= {p=1, t=1},	
		WEF_F_Thanks	= {p=1, t=1},	
	},			
	[2] = {			
		DW_Do_not_Swear	= {p=1, t=5},	
		DW_Earth_Death_Scheduled	= {p=10, t=5},	
		DW_Exterminate	= {p=1, t=5},	
		DW_Must_Survive	= {p=1, t=5},	
		DW_Owner_of_Blue_Box	= {p=1, t=5},	
		DW_TARDIS	= {p=1, t=5},	
		DW_Upgrading_is_compulsory	= {p=1, t=5},	
		DW_Weakest_Link	= {p=1, t=5},	
	},			
	[3] = {			
		HEF_F_Agree	= {p=1, t=1},	
		HEF_F_Disagree	= {p=1, t=1},	
		HEF_F_Follow	= {p=1, t=1},	
		HEF_F_Greet	= {p=1, t=1},	
		HEF_F_Heal	= {p=1, t=1},	
		HEF_F_Help	= {p=1, t=1},	
		HEF_F_Laugh	= {p=1, t=1},	
		HEF_F_Stop	= {p=1, t=1},	
		HEF_F_Thanks	= {p=1, t=1},	
	},			
}				
--	67	(35)		
local lootitems = {				
	[119813] = true, 	-- Furry Caged Beast		
	[119810] = true, 	-- Meaty Caged Beast		
	[119814] = true, 	-- Leathery Caged Beast		
	[119815] = true, 	-- Caged Mighty Wolf		
	[119817] = true, 	-- Caged Mighty Riverbeast		
	[119819] = true, 	-- Caged Mighty Clefthoof		
	[2589]   = true,	-- linen-cloth		
	[2592]   = true,	-- wool-cloth		
	[4306]   = true,	-- silk-cloth		
	[4338]   = true,	-- mageweave-cloth		
	[14047]  = true,	-- runecloth		
	[21877]  = true,	-- netherweave-cloth		
	[33470]  = true,	-- frostweave-cloth		
	[72988]  = true,	-- windwool-cloth		
	[111556]  = true,	-- hexweave-cloth		
}				
--	85	(18)		
-- chat funtions				
function addon:chatMsg(msg) 				
	addon:chatMsg1(addonName..": "..msg)			
end				
function addon:chatMsg1(msg) 				
	DEFAULT_CHAT_FRAME:AddMessage(msg)			
end				
--	93	(8)		
local skinning = GetSpellInfo(8613)				
local find_herbs = GetSpellInfo(2368)				
local find_mine = GetSpellInfo(2575)				
--	97	(4)		
function addon:doWork(u_skill)				
	if not settings or not settings.enabled then return end			
	local now = GetTime()			
	local pause = settings.playfrequency			
	if now < (addon.nextplay or 0) then return end			
				
	if settings.summon then			
		addon:pet_call()		
	end			
	if settings.sound then			
		local user = 0		
		if settings.link then user = settings.pet else user = settings.list end		
		pause = addon:soundplay(user,pause)		
	end			
	if settings.say then			
		addon:petsay(u_skill)		
	end			
	addon.nextplay = now + pause			
end				
--	117	(20)		
function addon:pet_out()				
	local petName			
	local pet_gu = addon:pet_type()			
	if pet_f==1 or settings.summon then 			
		local _, petHand, _, _, _, _, _, petRace  = C_PetJournal.GetPetInfoByPetID(pet_gu)		
		if not petHand then petHand = petRace end		
		petName=petHand		
	else			
		petName = "a voice from a distance"		
	end			
	return petName			
end				
--	130	(13)		
function addon:pet_av()				
	local pet_f			
	if C_PetJournal.GetSummonedPetGUID() then			
		pet_f=1		
	else			
		pet_f=0		
	end			
	return pet_f			
end				
--	140	(10)		
function addon:pet_type()				
	local pet,pet_gu			
	if addon:pet_av() then			
		pet = C_PetJournal.GetSummonedPetGUID()
	end			
	if settings.summon then pet_gu = pet_n[settings.pet] else pet_gu=pet end			
	return pet_gu,pet			
end				
--	151	(11)		
function addon:pet_call()				
	local pet_want = pet_n[settings.pet]			
	local _,pet = addon:pet_type()			
	if pet ~= pet_want then			
		C_PetJournal.SummonPetByGUID(pet_want)		
	end			
end				
--	159	(8)		
function addon:petsay(u_skill)				
	local petName = 0			
	local msg = deb_tex[u_skill]			
	SendChatMessage("hears " .. addon:pet_out() .. " say " .. "'" .. msg .. "'", "EMOTE");			
end				
--	165	(6)		
function addon:soundplay(pet_f,pause)				
	local soundtable = {}			
	local soundsum = 0			
	for name, data in pairs(soundfiles[pet_f]) do			
		local soundname = ("Interface\\AddOns\\"..addonName.."\\sound\\"..name..".mp3")		
		table.insert(soundtable, {		
			soundname, data.p, data.t	
			})	
		soundsum = soundsum + data.p		
	end			
	local roll = math.random(soundsum)			
	for i,e in ipairs(soundtable) do			
		local f,p,t = unpack(e)		
		roll = roll - p		
		if roll <= 0 then		
			PlaySoundFile(f, "Master")	
			pause = math.max(pause, t)	
			return pause	
		end		
	end			
end				
--	187	(22)		
function addon:Loot_Call(msg)				
	local itemstr = LOOT_ITEM_PUSHED_SELF:gsub("%%s","%(.*%)") -- for Skinning			
	local itemstr2 = LOOT_ITEM_SELF:gsub("%%s","%(.*%)") -- for tailery			
	local message = msg or ""			
	local link = message:match(itemstr)			
	local link2 = message:match(itemstr2) --			
	local hold			
	if (link) then hold = link else hold = link2 end			
	local id = hold and tonumber(hold:match("\124Hitem:(%d+):"))			
	if id and lootitems[id] then			
		addon:doWork(4)		
	end			
end				
--	201	(14)		
local function frame_OnEvent(self,event,...)				
	if event == "ADDON_LOADED" and select(1,...) == addonName then			
		if not Profession_RPSettings then		
			Profession_RPSettings = {} 	
		end		
		settings = Profession_RPSettings		
		for k,v in pairs(defaults) do		
			if settings[k] == nil then	
				settings[k] = v
			end	
		end		
	elseif event == "UNIT_SPELLCAST_START" then			
		local unitID, spell = ...		
		if unitID == "player" then		
			local spell_id = 0	
			if spell == skinning then	
				spell_id = 1
			elseif spell == find_herbs then	
				spell_id = 2
			elseif spell == find_mine then	
				spell_id = 3
			end	
			if spell_id ~= 0 then addon:doWork(spell_id) end	
		end		
	elseif event == "CHAT_MSG_LOOT" then			
		local arg1 = ...		
		addon:Loot_Call(arg1)		
	elseif event == "CHAT_MSG_WHISPER" and settings.debug then			
		addon:doWork(2)	--[[----]]--	
	end			
end				
--	233	(32)		
function addon:SlashHandler(msg)				
	if not msg then			
		return		
	else			
		local msgLower = msg:lower()		
		local wordsLower = addon:GetWords(msgLower)		
		local size = addon:TableSize(wordsLower)		
		local cmd = wordsLower[0]		
				
		if cmd == "on" then		
			settings.enabled = true	
			addon:chatMsg("Enabled.")	
		elseif cmd == "off" then		
			settings.enabled = false	
			addon:chatMsg("Disabled.")	
		elseif cmd == "sound" or cmd == "summon" or cmd == "say" or cmd == "link" or cmd == "debug" then		
			settings[cmd] = not settings[cmd]	
			addon:chatMsg(cmd.." "..(settings[cmd] and "enabled." or "disabled."))	
		elseif cmd == "list" or cmd == "pet" then		
			if (size>1) then	
				settings[cmd]=tonumber(wordsLower[1])
				addon:chatMsg(cmd.." now #" .. wordsLower[1])
			end	
		else		
			addon:ChatHelp()	
		end		
	end			
end				
--	262	(29)		
function addon:ChatHelp()				
	local c = 	{		
			[1] = "enabled",	
			[2] = "summon",	
			[3] = "say",	
			[4] = "sound",	
			[5] = "pet",	
			[6] = "list",	
			[7] = " | ",	
			[8] = "on",	
			[9] = "off",	
			[10] = " = ",	
		}		
	addon:chatMsg("Usage: "..addonsls.." [ on | off | summon | say | sound | pet | list | link ]")			
	if settings.enabled then c[1]= (c[1]..c[10]..c[8]) else c[1] = (c[1]..c[10]..c[9]) end			
	if settings.summon then c[2]= (c[2]..c[10]..c[8]) else c[2] = (c[2]..c[10]..c[9]) end			
	if settings.say then c[3]= (c[3]..c[10]..c[8]) else c[3] = (c[3]..c[10]..c[9]) end			
	if settings.sound then c[4]= (c[4]..c[10]..c[8]) else c[4] = (c[4]..c[10]..c[9]) end			
				
	local set =	{		
			[1] = (c[1]..c[7]),	
			[2] = (c[2]..c[7]),	
			[3] = (c[3]..c[7]),	
			[4] = (c[4]..c[7]),	
			[5]= (c[5]..c[10]..settings.pet..c[7]),	
			[6]=  (c[6]..c[10]..settings.list..c[7]),	
		}		
	addon:chatMsg("Usage: "..addonsls.." [ "..set[1]..set[2]..set[3])			
	addon:chatMsg("Usage: "..addonsls..set[4]..set[5]..set[6].." ]")			
end				
--	293	(31)		
function addon:TableSize(info)				
	local result = 0			
	if info then			
		for item in pairs(info) do result = result + 1 end		
	end			
	return result			
end				
--	301	(8)		
function addon:GetWords(str)				
	local ret = {};			
	local pos=0;			
	local index=0			
	while(true) do			
		local word;		
		_,pos,word=string.find(str, "^ *([^%s]+) *", pos+1);		
		if(not word) then		
			return ret;	
		end		
		ret[index]=word		
		index = index+1		
	end			
end				
--	316	(15)		
local frame = CreateFrame("Button", addonName.."HiddenFrame", UIParent)				
frame:SetScript("OnEvent", frame_OnEvent)				
frame:RegisterEvent("ADDON_LOADED")				
frame:RegisterEvent("UNIT_SPELLCAST_START")				
frame:RegisterEvent("CHAT_MSG_LOOT")				
frame:RegisterEvent("CHAT_MSG_WHISPER");				
--	323	(7)		
-- slash cmd function				
	hash_SlashCmdList[addonsls] = nil			
	SLASH_Profession_RP1 = addonsls			
	SlashCmdList[addonName] = function(msg)			
		addon:SlashHandler(msg)		
	end			
-- end slash cmd